// AmlPara.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include <stdio.h> //sprintf
#include <stdlib.h> //atol
#include <commctrl.h> //spin support
#include "resource.h"	//dialog resources
#include "PlugLocUtil.h"	//dialog resources

HINSTANCE m_hInst;
WORD g_wLangID=0;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  r, 
                       LPVOID lpReserved				
					   )
{
	if (DLL_PROCESS_ATTACH==r)//save DLL hModule
		m_hInst=(HINSTANCE)hModule;

    return TRUE;
}

enum {MI_LEFTINDENT=0	//menu "Left Indent"
	, MI_RIGHTINDENT=1	//menu "Right Indent"
	, MI_SEP=2
	, MI_TOP_ENCREASE=3	
	, MI_TOP_DECREASE=4
	, MI_SEP2=6
	, MI_LINE_SINGLE=8
	, MI_LINE_ONEANDHALF=9
	, MI_LINE_DOUBLE=10
	, MI_SEP3=11
	, MI_MERGE_TO_PARA=12
	, MI_COUNT=13
	};//menu "Right Indent"

//Line spacing constants
enum {LINE_SINGLE=0
	,LINE_ONEANDHALF=1
	,LINE_DOUBLE=2
};

#define PLUGMAKESTRING(PSTR,IDSTRING) PlugLoc::LoadStr(PSTR,PlugLoc::StringOrUINT(IDSTRING,#IDSTRING),g_wLangID,m_hInst)

/*Fill about plugin information*/
extern "C"
BOOL __declspec(dllexport) Aml_GetPluginInfo(AML_PLUGIN_INFO* p)
{
	if (p->cbSize>=SIZE_AML_PLUGIN_INFO_VER2)
		g_wLangID=p->wLanguage;

	p->nMenuCount=MI_COUNT;//set 2 menu items
	//strcpy(p->szMenuName,"Para Format (Sample)");//plugin title
	PLUGMAKESTRING(p->szMenuName,IDS_TITLE);
	return TRUE;
}


/*Fill menu items information*/
extern "C"
BOOL __declspec(dllexport) Aml_GetMenuItemInfo(UINT nIndex, AML_MENU_ITEM_INFO* p)
{
	BOOL bRet=TRUE;

	switch(nIndex) {
	case MI_LEFTINDENT://1st menu item
		strcpy(p->szFunctionName,"LeftIndentProc");//menu function
		//strcpy(p->szMenuName,"Left Indent...");//menu string
		PLUGMAKESTRING(p->szMenuName,IDS_LEFTINDENT);
		//strcpy(p->szSBHint,"Set left indent for the current paragraph");//menu hint
		PLUGMAKESTRING(p->szSBHint,IDS_LEFTINDENTTT);
		p->nPluginType=APPT_PAGECONTENT;//function type 
		p->dwFlags=APF_EDITMENU;//add the item to editors context menu
		break;
	case MI_RIGHTINDENT://2-st menu item
		strcpy(p->szFunctionName,"RightIndentProc");//menu function
		//strcpy(p->szMenuName,"Right Indent...");//menu string
		//strcpy(p->szSBHint,"Set right indent for the current paragraph");//menu hint
		PLUGMAKESTRING(p->szMenuName,IDS_RIGHTINDENT);
		PLUGMAKESTRING(p->szSBHint,IDS_RIGHTINDENTTT);
		p->nPluginType=APPT_PAGECONTENT;//function type
		p->dwFlags=APF_EDITMENU;//add the item to editors context menu
		break;
	case MI_SEP3://menu separators (p->szFunctionName not defined)
	case MI_SEP2://menu separators (p->szFunctionName not defined)
	case MI_SEP:
		p->dwFlags=APF_EDITMENU;//add the item to editors context menu
		break;
	case MI_TOP_ENCREASE:
		strcpy(p->szFunctionName,"ParaAboveEncrease");//menu function
		//strcpy(p->szMenuName,"Encrease Para Spacing");//menu string
		//strcpy(p->szSBHint,"Encrease Para Spacing Above");//menu hint
		p->nPluginType=APPT_PAGECONTENT;//function type
		PLUGMAKESTRING(p->szMenuName,IDS_INCPARA);
		PLUGMAKESTRING(p->szSBHint,IDS_INCPARATT);
		p->dwFlags=APF_EDITMENU;//add the item to editors context menu
		break;
	case MI_TOP_DECREASE:
		strcpy(p->szFunctionName,"ParaAboveDecrease");//menu function
		//strcpy(p->szMenuName,"Decrease Para Spacing");//menu string
		//strcpy(p->szSBHint,"Decrease Para Spacing Above");//menu hint
		PLUGMAKESTRING(p->szMenuName,IDS_DECPARA);
		PLUGMAKESTRING(p->szSBHint,IDS_DECPARATT);

		p->nPluginType=APPT_PAGECONTENT;//function type
		p->dwFlags=APF_EDITMENU;//add the item to editors context menu
		break;
	case MI_LINE_SINGLE:
		strcpy(p->szFunctionName,"LineProc");//menu function
		//strcpy(p->szMenuName,"Single Line");//menu string
		//strcpy(p->szSBHint,"Single Line Spacing");//menu hint
		PLUGMAKESTRING(p->szMenuName,IDS_SINGLELINE);
		PLUGMAKESTRING(p->szSBHint,IDS_SINGLELINETT);

		p->nPluginType=APPT_PAGECONTENT;//function type
		p->dwFlags=APF_EDITMENU;//add the item to editors context menu
		p->lParam=LINE_SINGLE;//save line spacing constanc into lParam
		break;
	case MI_LINE_ONEANDHALF:
		strcpy(p->szFunctionName,"LineProc");//menu function
		//strcpy(p->szMenuName,"One And Half Line");//menu string
		//strcpy(p->szSBHint,"One And Half Line Spacing");//menu hint
		PLUGMAKESTRING(p->szMenuName,IDS_ONEANDHALFLINE);
		PLUGMAKESTRING(p->szSBHint,IDS_ONEANDHALFLINETT);

		p->nPluginType=APPT_PAGECONTENT;//function type
		p->dwFlags=APF_EDITMENU;//add the item to editors context menu
		p->lParam=LINE_ONEANDHALF;//save line spacing constanc into lParam
		break;
	case MI_LINE_DOUBLE:
		strcpy(p->szFunctionName,"LineProc");//menu function
		//strcpy(p->szMenuName,"Double Line");//menu string
		//strcpy(p->szSBHint,"Double Spacing");//menu hint
		PLUGMAKESTRING(p->szMenuName,IDS_DOUBLELINE);
		PLUGMAKESTRING(p->szSBHint,IDS_DOUBLELINETT);

		p->nPluginType=APPT_PAGECONTENT;//function type
		p->dwFlags=APF_EDITMENU;//add the item to editors context menu
		p->lParam=LINE_DOUBLE;//save line spacing constanc into lParam
		break;
	case MI_MERGE_TO_PARA:
		strcpy(p->szFunctionName,"MergeToParaProc");//menu function
		//strcpy(p->szMenuName,"Merge To Para");//menu string
		//strcpy(p->szSBHint,"Merge to single para");//menu hint
		PLUGMAKESTRING(p->szMenuName,IDS_MERGETOPARA);
		PLUGMAKESTRING(p->szSBHint,IDS_MERGETOPARATT);

		p->nPluginType=APPT_PAGECONTENT;//function type
		p->dwFlags=APF_EDITMENU;//add the item to editors context menu
		break;
	default:
		bRet=FALSE;
	}

	return bRet;
}

//varaibles for dialog "Enter Indent"
int m_nValueBuff;
char szDialogTitle[250]={0};

//Dialog procedure for dialog "Enter Indent"
LRESULT CALLBACK DlgValueProc(HWND hwnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
	switch(nMsg) {
	case WM_INITDIALOG:
		{
		const HWND hwndEdit=GetDlgItem(hwnd,IDC_EDIT);
		char sz[4]={0};
		sprintf(sz,"%d",m_nValueBuff);
		SendMessage(hwndEdit,EM_LIMITTEXT,4,0);
		SetWindowText(hwndEdit,sz);
		if (strlen(szDialogTitle))
			SetWindowText(hwnd,szDialogTitle);

		const HWND hwndSpin=GetDlgItem(hwnd,IDC_SPIN);
		SendMessage(hwndSpin,UDM_SETBUDDY,(WPARAM)hwndEdit,0);
		SendMessage(hwndSpin,UDM_SETRANGE,0,MAKELONG(9999,0));
		SendMessage(hwndSpin,UDM_SETPOS,0,MAKELONG(m_nValueBuff,0));
		return TRUE;
		}
		break;
	case WM_COMMAND:
		if (LOWORD(wParam)==IDOK) {
			char sz[5]={0};
			const HWND hwndEdit=GetDlgItem(hwnd,IDC_EDIT);
			GetWindowText(hwndEdit,sz,4);
			m_nValueBuff=atol(sz);
			EndDialog(hwnd,LOWORD(wParam));
		}
		else if (IDCANCEL==LOWORD(wParam)) {
			EndDialog(hwnd,LOWORD(wParam));
		}
		
		break;
	};

	return FALSE;
}

//Ask indent value
int GetValue(const int nInitValue, LPCTSTR lpszText)
{
	m_nValueBuff=nInitValue;
	if (!IsBadStringPtr(lpszText,INFINITE)) {
		strcpy(szDialogTitle,lpszText);
	}
	const int n=::DialogBox(m_hInst,MAKEINTRESOURCE(IDD_DLGVALUE),APPHelper::GetMainHWND(),(DLGPROC)DlgValueProc);
	if (IDOK==n) {
		return m_nValueBuff;
	}
	else
		return nInitValue;
}

//Retrieve current para indent
bool GetParaIndent(const HWND hwnd	//hwnd Richedit
				   ,const DWORD dwMask	//mask of indent
				   ,int& nValue	//new indent
				   , LPCTSTR lpszDlgTitle	//dialog title
				   )
{
	//Get default value from RichEdit
	PARAFORMAT pf={0};
	pf.cbSize=sizeof(pf);
	pf.dwMask=dwMask;
	SendMessage(hwnd,EM_GETPARAFORMAT,0,(LPARAM)&pf);

	//nInitValue in twips
	const int nInitValue=PFM_RIGHTINDENT==dwMask ? pf.dxRightIndent: pf.dxStartIndent;

	//Ask indent value from dialog
	nValue=GetValue(nInitValue,lpszDlgTitle);
	return (nInitValue!=nValue);
}

BOOL IndentProc(AML_PAGECONTENT* p, const bool bLeft)
{
	if (p->cbSize<SIZE_AML_PAGECONTENT_VER2) {//Old version AML_PAGECONTENT????
		char sz[]="Required Aml Pages 9.00 b1825 or later";
		MessageBox(APPHelper::GetMainHWND(),sz,"Aml Para",MB_ICONEXCLAMATION);
		return FALSE;//Error
	}

#ifndef _DEBUG
	if (PT_RTF!=p->pageType) {//Type of page not formatted text????
		char sz[]="Required page as formatted text.\nPlain text page cant save text formatting";
		MessageBox(APPHelper::GetMainHWND(),sz,"Aml Para",MB_ICONEXCLAMATION);
		return FALSE;//Error
	}
#endif//#ifndef _DEBUG
	
	PARAFORMAT pf={0};
	pf.cbSize=sizeof(pf);
	pf.dwMask=bLeft ? (PFM_OFFSETINDENT|PFM_STARTINDENT) : PFM_RIGHTINDENT;
	
	int nNewValue;
	BOOL bRet=TRUE;
	//Get new indent value from user?
	if (GetParaIndent(p->hwnd,	pf.dwMask,nNewValue,bLeft ? "Left Indent" : "Right Indent")) {
		//Set Indent value
		if (PFM_RIGHTINDENT==pf.dwMask)
			pf.dxRightIndent=nNewValue;
		else
			pf.dxStartIndent=nNewValue;

		bRet=SendMessage(p->hwnd,EM_SETPARAFORMAT,0,(LPARAM)&pf);
	}

	return bRet;
}

extern "C"
BOOL __declspec(dllexport) LeftIndentProc(AML_PAGECONTENT* p)
{
	//Process Left Indent
	return IndentProc(p,true);
}

extern "C"
BOOL __declspec(dllexport) RightIndentProc(AML_PAGECONTENT* p)
{
	//Process Right Indent
	return IndentProc(p,false);
}

//Para above spacing procedure
BOOL ProcessParaAbove(const HWND hwnd, const bool bNeg)
{
	PARAFORMAT2 pf;
	memset(&pf,0,sizeof(pf));
	pf.cbSize=sizeof(pf);
	pf.dwMask=PFM_SPACEBEFORE;
	::SendMessage(hwnd,EM_GETPARAFORMAT,0,(LPARAM)&pf);
	const int delta=bNeg ? -100 : 100;
	pf.dySpaceBefore+=delta;

	pf.dwMask=PFM_SPACEBEFORE;
	const BOOL b=::SendMessage(hwnd,EM_SETPARAFORMAT,0,(LPARAM)&pf);
	return b;
}

extern "C"
BOOL __declspec(dllexport) ParaAboveEncrease(AML_PAGECONTENT* p)
{
	return ProcessParaAbove(p->hwnd,false);
}

extern "C"
BOOL __declspec(dllexport) ParaAboveDecrease(AML_PAGECONTENT* p)
{
	//p->hwnd HWND of Aml Pages Text Editor
	return ProcessParaAbove(p->hwnd,true);
}

extern "C"
BOOL __declspec(dllexport) LineProc(AML_PAGECONTENT* p)
{
	//p->hwnd HWND of Aml Pages Text Editor
	PARAFORMAT2 pf;
	memset(&pf,0,sizeof(pf));
	pf.cbSize=sizeof(pf);
	pf.dwMask=PFM_LINESPACING;//mask
	//line spacing constant are saved in lParam in Aml_GetMenuItemInfo Handler
	pf.bLineSpacingRule=(BYTE)p->lParam;

	const BOOL b=SendMessage(p->hwnd,EM_SETPARAFORMAT,0,(LPARAM)&pf);
	if (b)
		SendMessage(p->hwnd,EM_SETMODIFY,TRUE,0);
	return b;
}

class RedrawHWNDLocker {
	const HWND m_hwnd;	
public:
	RedrawHWNDLocker(HWND wnd):m_hwnd(wnd) {
		SendMessage(m_hwnd,WM_SETREDRAW,FALSE,0);
	}
	~RedrawHWNDLocker() {
		SendMessage(m_hwnd,WM_SETREDRAW,TRUE,0);
		RECT r={0};
		::GetClientRect(m_hwnd,&r);
		RedrawWindow(m_hwnd,&r,NULL,RDW_INVALIDATE|RDW_UPDATENOW);
	}
};//class RedrawWndLocker {

long Replace(const HWND hwnd, const CHARRANGE cr, LPCTSTR lpszFind, LPCTSTR lpszReplace, const UINT nAddedDelta)
{
	FINDTEXTEX ft={0};
	ft.chrg.cpMin=cr.cpMin;
	ft.chrg.cpMax=cr.cpMax;
	ft.lpstrText=(LPTSTR)lpszFind;
	const UINT nDelta=strlen(lpszFind)-strlen(lpszReplace);

#ifndef FR_DOWN
	#define FR_DOWN 1
#endif
	long l=0;
	while (((long)SendMessage(hwnd,EM_FINDTEXTEX,FR_DOWN,(LPARAM)&ft)>0)) {
		ft.chrgText.cpMax+=nAddedDelta;
		::SendMessage(hwnd,EM_EXSETSEL,0,(LPARAM)&ft.chrgText);
		::SendMessage(hwnd,EM_REPLACESEL,TRUE,(LPARAM)lpszReplace);
		ft.chrg.cpMin=ft.chrgText.cpMax;
		ft.chrg.cpMax-=nDelta;
		l++;
	}
	return l;
}

#ifndef EM_STOPGROUPTYPING
#define EM_STOPGROUPTYPING		(WM_USER + 88)
#endif

extern "C"
BOOL __declspec(dllexport) MergeToParaProc(AML_PAGECONTENT* p)
{
	if (p->crSel.cpMax==p->crSel.cpMin) {
		MessageBeep((UINT)-1);
		return TRUE;
	}

	SendMessage(p->hwnd,EM_STOPGROUPTYPING,0,0);
	RedrawHWNDLocker redraw_locked(p->hwnd);

	while(Replace(p->hwnd,p->crSel,"\r"," ",1));
	while (Replace(p->hwnd,p->crSel,"  "," ",0));


	return TRUE;
}

